--- src/northsouthbridge/sis/630/raminit.inc	Tue Mar 18 21:02:32 2003
+++ src/northsouthbridge/sis/630/raminit.inc.new	Tue Mar 18 21:05:04 2003
@@ -87,9 +87,31 @@
 #endif
 
 #ifdef DISABLE_INTERNAL_DEVICES
-	movw	$0x7c0e, %ax			# Writting undocumented LPC register
-write_lpc_register:
+#warning *********** EMBEDDED DEVICES DISABLED
 	/* Input: AH - register number. AL - register value. */
+        movw   $0x7c0f,%ax                      # Initial value for the undocumented SIS LPC register
+                                                # Disable everything by default
+ 
+#ifdef ENABLE_INTERNAL_AUDIO
+#warning *********** AUDIO ENABLED
+        andb    $0x0e,%al
+#endif
+
+#ifdef ENABLE_INTERNAL_MODEM
+#warning *********** MODEM ENABLED
+        andb   $0x0d,%al
+#endif
+
+#ifdef ENABLE_INTERNAL_LAN
+#warning *********** LAN ENABLED
+        andb   $0x0b,%al
+#endif
+
+#ifdef ENABLE_INTERNAL_USB
+#warning *********** USB ENABLED
+        andb   $0x07,%al
+#endif
+
 	movl	$LPC_BRIDGE_BASE_ADDR, %edx
 	movl	%eax, %ebx			# Save %eax to %ebx.
 
--- src/mainboard/pcchips/m787cl+/Config	Mon Dec 16 21:03:15 2002
+++ src/mainboard/pcchips/m787cl+/Config	Tue Mar 18 16:50:46 2003
@@ -11,6 +11,15 @@
 # I prefer 38400 for console
 option TTYS0_BAUD=38400
 
+# Disable all embedded devices
+#option DISABLE_INTERNAL_DEVICES=1
+# Enable some of the devices individually
+# These options are only valid if DISABLE_INTERNAL_DEVICES is set
+#option ENABLE_INTERNAL_AUDIO=1
+#option ENABLE_INTERNAL_MODEM=1
+#option ENABLE_INTERNAL_USB=1
+#option ENABLE_INTERNAL_LAN=1
+
 mainboardinit superio/sis/950/setup_serial.inc
 mainboardinit pc80/serial.inc
 mainboardinit arch/i386/lib/console.inc
--- util/config/pcchips787.config	Tue Mar 18 17:07:12 2003
+++ util/config/pcchips787.config.new	Tue Mar 18 17:04:32 2003
@@ -13,6 +13,15 @@
 # PCCHIPS m787cl+ mainboard
 mainboard pcchips/m787cl+
 
+# Disable all embedded devices
+#option DISABLE_INTERNAL_DEVICES=1
+# Enable some of the devices individually
+# These options are only valid if DISABLE_INTERNAL_DEVICES is set
+#option ENABLE_INTERNAL_AUDIO=1
+#option ENABLE_INTERNAL_MODEM=1
+#option ENABLE_INTERNAL_USB=1
+#option ENABLE_INTERNAL_LAN=1
+
 #this sets the vga memory small since
 #text console uses very little
 option SMA_SIZE=0x80
